
import dnx.lr.*;
import dnx.lr.app.*;
import java.awt.*;
import java.net.URL;


public class SimpleViewer
{
   public static void main(String args[])
   {
      Scene scene = null;
      try {
         // Create a scene, but tell it not to initialize itself yet from
         // the contents of the scene.  That way the BrowserEngine inside
         // of the BrowserNexus will correctly initialize itself.  See
         // the documentation for BrowserNexus.
         scene = new Scene (new ReadAction (new URL (ApplicationDocument.getCurrentDirectory(),
args[0])), false);
      } catch (VRMLSyntaxException e) {
         System.out.println ("Unable to load: " + e);
         return;
      } catch (java.io.IOException e) {
         System.out.println ("Unable to load: " + e);
         return;
      }
      // Create a document, a nexus, and a view.
      ApplicationDocument document = new ApplicationDocument(scene);
      Frame frame = new Frame("Simple VRML Viewer"); // Create a new frame
      frame.setLayout(new FlowLayout());             // Set its layout manager

      BrowserNexus nexus = new BrowserNexus(document, frame);
      View3D view = new View3D(nexus, 400, 300);

      // Give the nexus a view.
      nexus.addView(view);

      // Add the nexus to the document
      document.addNexus(nexus);

      frame.add(view.getView3DCanvas());         // Add the view's canvas
      frame.resize(new Dimension(440, 340));     // Resize and show the frame
      frame.show();

      // Now initialize the scene from its contents.  This will cause
      // a flurry of SceneObserverEvents to get sent out, which will
      // get noticed by the document and passed to the BrowserNexus.
      scene.setRootFromContents();

      // Run the document, causing periodic "scene frames" (event
      // dispatching and redisplay)
      document.start();
   }
}
